#!/usr/bin/env python

import argparse
from pytx import Malware


def run(md5s):
    """
    Print the malware object for each md5 hash passed in.

    :param md5s: A list of hashes
    :type md5s: enumerable strs
    """
    for md5 in md5s:
        print Malware.objects(text=md5, strict_text=True, full_response=True)


def get_args():
    parser = argparse.ArgumentParser(description='Grab Malware Objects from ThreatExchange')
    parser.add_argument('-m', '--md5s', default=[], action='append',
                        help='[OPTIONAL] md5 hash to lookup. May be specified more than once.')
    return parser.parse_args()


def main():
    args = get_args()

    # Set a default hash if none was specified
    if not args.md5s:
        args.md5s = ['681f1b31baa671a81e4b803dbf8a9f10']

    run(args.md5s)

if __name__ == '__main__':
    main()
